/*
              Copyright (C) 1993 - 2001   Masahito Yamaga

Permission to use, copy, and distribute this package and its documentation
for any purpose is granted, provided that this permission notice is included
in supporting documentation.

Permission to modify this package is also granted, but please send an e-mail
to Yamaga (ma@yama-ga.com) in case of distributing the modified code.

This package provides NO WARRANTY. You can use this at your own risks.

Copyrights on this package belong to Masahito Yamaga, but GNUPLOT's to Mr.
Thomas Williams and Mr. Colin Kelley (See "Copyright" in the original GNUPLOT
source package).

Distribution of GNUPLOT that has been applied this patch to (especially
binaries) has to be very carefully done. See "Copyright" in the original
GNUPLOT source package.

                                   2001/01/11 Masahito Yamaga(ma@yama-ga.com)
*/

#ifndef _GPPLUSCOM_H
#define _GPPLUSCOM_H

/* Greek letter */
REPLACEWORD("\\alpha"     ,"{\\O\\sm a}");
REPLACEWORD("\\beta"      ,"{\\O\\sm b}");
REPLACEWORD("\\chi"       ,"{\\O\\sm c}");
REPLACEWORD("\\delta"     ,"{\\O\\sm d}");
REPLACEWORD("\\varepsilon","{\\O\\sm e}");
REPLACEWORD("\\phi"       ,"{\\O\\sm f}");
REPLACEWORD("\\gamma"     ,"{\\O\\sm g}");
REPLACEWORD("\\eta"       ,"{\\O\\sm h}");
REPLACEWORD("\\iota"      ,"{\\O\\sm i}");
REPLACEWORD("\\varphi"    ,"{\\O\\sm j}");
REPLACEWORD("\\kappa"     ,"{\\O\\sm k}");
REPLACEWORD("\\lambda"    ,"{\\O\\sm l}");
REPLACEWORD("\\mu"        ,"{\\O\\sm m}");
REPLACEWORD("\\nu"        ,"{\\O\\sm n}");
REPLACEWORD("\\pi"        ,"{\\O\\sm p}");
REPLACEWORD("\\theta"     ,"{\\O\\sm q}");
REPLACEWORD("\\rho"       ,"{\\O\\sm r}");
REPLACEWORD("\\sigma"     ,"{\\O\\sm s}");
REPLACEWORD("\\tau"       ,"{\\O\\sm t}");
REPLACEWORD("\\upsilon"   ,"{\\O\\sm u}");
REPLACEWORD("\\varpi"     ,"{\\O\\sm v}");
REPLACEWORD("\\omega"     ,"{\\O\\sm w}");
REPLACEWORD("\\xi"        ,"{\\O\\sm x}");
REPLACEWORD("\\psi"       ,"{\\O\\sm y}");
REPLACEWORD("\\zeta"      ,"{\\O\\sm z}");
REPLACEWORD("\\Delta"     ,"{\\O\\sm D}");
REPLACEWORD("\\Phi"       ,"{\\O\\sm F}");
REPLACEWORD("\\Gamma"     ,"{\\O\\sm G}");
REPLACEWORD("\\vartheta"  ,"{\\O\\sm J}");
REPLACEWORD("\\Lambda"    ,"{\\O\\sm L}");
REPLACEWORD("\\Pi"        ,"{\\O\\sm P}");
REPLACEWORD("\\Theta"     ,"{\\O\\sm Q}");
REPLACEWORD("\\Sigma"     ,"{\\O\\sm S}");
REPLACEWORD("\\Upsilon"   ,"{\\O\\sm U}");
REPLACEWORD("\\varsigma"  ,"{\\O\\sm V}");
REPLACEWORD("\\Omega"     ,"{\\O\\sm W}");
REPLACEWORD("\\Xi"        ,"{\\O\\sm X}");
REPLACEWORD("\\Psi"       ,"{\\O\\sm Y}");

/* LaTeX like command */
REPLACEWORD("\\ "        ,"@NULL@");
REPLACEWORD("\\{"        ,"\\173");
REPLACEWORD("\\}"        ,"\\175");
REPLACEWORD("\\$"        ,"\\044");
REPLACEWORD("\\^"        ,"\\136");
REPLACEWORD("\\_"        ,"\\137");
REPLACEWORD("\\backslash","\\134");
REPLACEWORD("\\cdot"     ,"\\264");
REPLACEWORD("\\sim"      ,"\\176");
REPLACEWORD("\\dagger"   ,"\\262");
REPLACEWORD("\\dag"      ,"\\262");
REPLACEWORD("\\ddag"     ,"\\263");
REPLACEWORD("\\div"      ,"{\\sm \\270}");
REPLACEWORD("\\pm"       ,"{\\sm \\261}");
REPLACEWORD("\\times"    ,"{\\sm \\264}");
REPLACEWORD("\\surd"     ,"{\\sm \\326}");
REPLACEWORD("\\langle"   ,"{\\sm \\341}");
REPLACEWORD("\\rangle"   ,"{\\sm \\361}");
REPLACEWORD("\\nabla"    ,"{\\sm \\321}");
REPLACEWORD("\\leq"      ,"{\\sm \\243}");
REPLACEWORD("\\le"       ,"{\\sm \\243}");
REPLACEWORD("\\geq"      ,"{\\sm \\263}");
REPLACEWORD("\\ge"       ,"{\\sm \\263}");
REPLACEWORD("\\neq"      ,"{\\sm \\271}");
REPLACEWORD("\\ne"       ,"{\\sm \\271}");
REPLACEWORD("\\equiv"    ,"{\\sm \\272}");
REPLACEWORD("\\cong"     ,"{\\sm \\100}");
REPLACEWORD("\\propto"   ,"{\\sm \\265}");
REPLACEWORD("\\approx"   ,"{\\sm \\273}");
REPLACEWORD("\\aleph"    ,"{\\sm \\300}");
REPLACEWORD("\\imath"    ,"{\\sm \\151}");
REPLACEWORD("\\smallint" ,"{\\sm \\362}");
REPLACEWORD("\\Im"       ,"{\\sm \\301}");
REPLACEWORD("\\Re"       ,"{\\sm \\302}");
REPLACEWORD("\\wp"       ,"{\\sm \\303}");
REPLACEWORD("\\angle"    ,"{\\sm \\320}");
REPLACEWORD("\\partial"  ,"{\\sm \\266}");
REPLACEWORD("\\infty"    ,"{\\sm \\245}");
REPLACEWORD("\\sum"      ,"{\\sm \\345}");
REPLACEWORD("\\bigl("    ,"{\\V\\sm\\scriptsize \\050}");
REPLACEWORD("\\bigr)"    ,"{\\V\\sm\\scriptsize \\051}");
REPLACEWORD("\\bigl\\{"  ,"{\\V\\sm\\scriptsize \\173}");
REPLACEWORD("\\bigr\\}"  ,"{\\V\\sm\\scriptsize \\175}");

/* original command for \frac{}{} */
REPLACEWORD("\\fracsqrt{",
	"{\\V\\sm\\scriptsize \\326}\\overline{{\\V\\scriptsize @NULL@}");
REPLACEWORD("\\fracoverline{","\\overline{{\\V\\scriptsize @NULL@}");

/* arrow */
REPLACEWORD("\\leftrightarrow" ,"{\\sm \\253}");
REPLACEWORD("\\leftarrow"      ,"{\\sm \\254}");
REPLACEWORD("\\uparrow"        ,"{\\sm \\255}");
REPLACEWORD("\\rightarrow"     ,"{\\sm \\256}");
REPLACEWORD("\\downarrow"      ,"{\\sm \\257}");
REPLACEWORD("\\Leftrightarrow" ,"{\\sm \\333}");
REPLACEWORD("\\Leftarrow"      ,"{\\sm \\334}");
REPLACEWORD("\\Uparrow"        ,"{\\sm \\335}");
REPLACEWORD("\\Rightarrow"     ,"{\\sm \\336}");
REPLACEWORD("\\Downarrow"      ,"{\\sm \\337}");

/* function */
REPLACEWORD("\\arccos" ,"{\\rm arccos}");
REPLACEWORD("\\arcsin" ,"{\\rm arcsin}");
REPLACEWORD("\\arctan" ,"{\\rm arctan}");
REPLACEWORD("\\arg"    ,"{\\rm arg}");
REPLACEWORD("\\cosh"   ,"{\\rm cosh}");
REPLACEWORD("\\cos"    ,"{\\rm cos}");
REPLACEWORD("\\coth"   ,"{\\rm coth}");
REPLACEWORD("\\cot"    ,"{\\rm cot}");
REPLACEWORD("\\cse"    ,"{\\rm cse}");
REPLACEWORD("\\deg"    ,"{\\rm deg}");
REPLACEWORD("\\det"    ,"{\\rm det}");
REPLACEWORD("\\dim"    ,"{\\rm dim}");
REPLACEWORD("\\exp"    ,"{\\rm exp}");
REPLACEWORD("\\gcd"    ,"{\\rm gcd}");
REPLACEWORD("\\hom"    ,"{\\rm hom}");
REPLACEWORD("\\inf"    ,"{\\rm inf}");
REPLACEWORD("\\ker"    ,"{\\rm ker}");
REPLACEWORD("\\lg"     ,"{\\rm lg}");
REPLACEWORD("\\liminf" ,"{\\rm lim inf}");
REPLACEWORD("\\limsup" ,"{\\rm lim sup}");
REPLACEWORD("\\lim"    ,"{\\rm lim}");
REPLACEWORD("\\ln"     ,"{\\rm ln}");
REPLACEWORD("\\log"    ,"{\\rm log}");
REPLACEWORD("\\max"    ,"{\\rm max}");
REPLACEWORD("\\min"    ,"{\\rm min}");
REPLACEWORD("\\Pr"     ,"{\\rm Pr}");
REPLACEWORD("\\sec"    ,"{\\rm sec}");
REPLACEWORD("\\sinh"   ,"{\\rm sinh}");
REPLACEWORD("\\sin"    ,"{\\rm sin}");
REPLACEWORD("\\sup"    ,"{\\rm sup}");
REPLACEWORD("\\tanh"   ,"{\\rm tanh}");
REPLACEWORD("\\tan"    ,"{\\rm tan}");

/* other letter */
REPLACEWORD("\\hbar"     ,"{\\nsm h}");
REPLACEWORD("\\epsilon"  ,"{\\nsm \\017}");
REPLACEWORD("\\aa"       ,"{\\iso \\345}");
REPLACEWORD("\\AA"       ,"{\\iso \\305}");
REPLACEWORD("\\ae"       ,"\\361");
REPLACEWORD("\\AE"       ,"\\341");
REPLACEWORD("\\l"        ,"\\370");
REPLACEWORD("\\L"        ,"\\350");
REPLACEWORD("\\oe"       ,"\\372");
REPLACEWORD("\\OE"       ,"\\352");
REPLACEWORD("\\ss"       ,"\\373");
REPLACEWORD("\\o"        ,"\\371");
REPLACEWORD("\\O"        ,"\\351");
REPLACEWORD("\\P"        ,"\\266");
REPLACEWORD("\\S"        ,"\\247");
REPLACEWORD("\\pounds"   ,"\\243");
REPLACEWORD("\\copyright","{\\iso \\251}");

#endif /* _GPPLUSCOM_H */
